# this procedure only attachs .?ut into .?lo 's according "cuts" mask in the
# given directory

proc process_dir { cuts } {
 global outbound
 foreach i $cuts {
  puts stdout [string range $i [expr [string length $i] - 3 ] end ]
  if { [expr  {[string range $i [expr [string length $i] - 3 ] end ] == "SUT"} || \
    {[string range $i [expr [string length $i] - 3 ] end ] == "TUT"} ] } {
   puts stdout "Boring file $i"
  } else  {
#  puts stdout $i
#  set splitted_filename [split $i /]
#  set name [lindex $splitted_filename [expr [llength $splitted_filename] -1 ]]
#  set name_wo_ext [lindex [split $name .] 0]
  set pkt [format "%s.pkt"  [file rootname $i] ]
#  puts stdout "Proposed PKT name $pkt"
#  looking for sutable name for new pkt file...
  while [file exists $pkt] {
#   puts stdout "$pkt exists"
   set name_wo_ext [file rootname [file tail $pkt]]
#   puts stdout "Name wo ext $name_wo_ext"
   set name_as_dec [expr [format "0x%s" $name_wo_ext] ]
#   puts stdout "Name as decimal $name_as_dec"
   set pkt [format "%s/%08x.pkt" $outbound [incr name_as_dec]]
#   puts stdout "New Proposed PKT name $pkt"
   if {![file exists $pkt]} break
  }

#  puts stdout "$pkt not exists"
   set flavour [string index $i [expr [string length $i] - 3]]
#  puts stdout "Flavour is $flavour"
   set clofile [format "%s.%slo" [file rootname $i]  $flavour]
   set bsyfile [format "%s.bsy"  [file rootname $i] ]
#   puts stdout "clofile is $clofile , bsy is $bsyfile"

  if  {![ file exist $bsyfile]} {
#   puts stdout "Bsy not exists - creating "
   close [ open  $bsyfile "w"]
   set clohandle [open $clofile "a"]

###
### OS2 Stuff
### unix users comment from here
   set splitted_filename [file split $pkt]
   set newname ""
   foreach j $splitted_filename {
    if [string length $newname] {
     set newname [format "%s\\%s" $newname $j]
    } else {
     set newname [string range $i 0 1]
    }
#    puts stdout "newname $newname"
   }
### to here, use
# set newname $pkt
###

   puts $clohandle [format "^%s" $newname]
   close $clohandle
   file rename $i $pkt
   puts stdout "$i => $newname \[$clofile\]"
   file delete $bsyfile
  } else {
   puts stdout "($bsyfile)"
  }
#   file rename $i $pkt

 } 
# not .TUT or SUT
 } 
# foreach
}
# processdir

###############################################################################
################################# Main procedure #############################

puts stderr "att_uts-Attach .?ut into .?lo program for BSO 0.00.02 by Dmitry the Zuryanovich"
puts stderr "ver 0.00.01 Aug 1998"
if  {[llength $argv] != 1} {
 puts stderr "Argument should be: path_to_outbound"
 puts stderr "example: tclsh att_uts c:/usr/fido/out \nNote: outbound must have FORWARD slashes"
 exit
}

# main outbound directory
set outbound [lindex $argv 0]
set cuts [glob -nocomplain [format "%s/*.?ut" $outbound]]
process_dir $cuts

set currd [format "%s/*.pnt" $outbound]
#puts stdout "$currd"
set pntdirs [glob -nocomplain $currd]
foreach i $pntdirs {
 set cuts [glob -nocomplain [format "%s/*.?ut" $i] ]
 process_dir $cuts
}
puts stderr "All done"
